/*
 * File:   main.c
 * Author: controllerstech
 *
 * Created on December 9, 2023, 11:56 AM
 */

#define F_CPU 5000000// </editor-fold>
#define EEPROMADDR 0x50

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "I2C_Master.h"
#include <string.h>


void clkInit(void)
{
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLA, 0);  // Internal 20MHz OSC, CLKOUT=0
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, 0x03);  // PEN=1, DIV=4
	while ((CLKCTRL.MCLKSTATUS & (1<<4)) == 0);  // wait for the osc to stabilize.
}


uint8_t datatowrite[] = "12345";

uint8_t eepromwrite[20];
uint8_t eepromread[20];

int main(void) {
    clkInit();
    I2C_Init();
    _delay_ms(100);
    
    eepromwrite[0] = 0;
    eepromwrite[1] = 0x25;   // 15 bit address = 0x25 -> {eepromwrite[0] :: eepromwrite[1]} -> {0x0025}
    memcpy((uint8_t *)eepromwrite+2, "12345", 5);
    
    I2C_Write(EEPROMADDR, eepromwrite, 7);
    _delay_ms(1000);
    
    I2C_Read(EEPROMADDR, 0x0025, 2, eepromread, 5);
    
    while (1) {

    }
}
